import { Observable, BehaviorSubject } from 'rxjs/Rx';
import { Keycloak } from './keycloak.core.service';
import 'rxjs/operator/map';
/**
 * Keycloak Authorization manager.
 *
 * Manager authorization headers and tokens to access to protected resources.
 */
export declare function teste(resourceSeververId: string): Observable<any>;
export declare class KeycloakAuthorization {
    private keycloak;
    static config: any;
    static initializedBehaviourSubject: BehaviorSubject<boolean>;
    static initializedObs: Observable<boolean>;
    static rpt: string;
    /**
     * This method enables client applications to better integrate with resource servers protected by a Keycloak
     * policy enforcer.
     *
     * In this case, the resource server will respond with a 401 status code and a WWW-Authenticate header holding the
     * necessary information to ask a Keycloak server for authorization data using both UMA and Entitlement protocol,
     * depending on how the policy enforcer at the resource server was configured.
     */
    static authorize(wwwAuthenticateHeader: string): Observable<any>;
    /**
     * Obtains all entitlements from a Keycloak Server based on a give resourceServerId.
     */
    static entitlement(resourceSeververId: string): Observable<any>;
    constructor(keycloak: Keycloak);
    init(): void;
}
