import { Http, Response, RequestOptionsArgs, RequestOptions, ConnectionBackend } from '@angular/http';
import { Observable, BehaviorSubject } from 'rxjs/Rx';
import 'rxjs/operator/map';
import 'rxjs/operator/filter';
import 'rxjs/operator/catch';
import { KeycloakAuthorization } from '../services/keycloak.auth.service';
import { Keycloak } from '../services/keycloak.core.service';
/**
 * An Angular http proxy supporting Keycloak auth & authz.
 * Authenticate user, manage tokens and add authorization header to access to remote Keycloak protected resources.
 */
export declare class KeycloakHttp extends Http {
    private keycloak;
    private keycloakAuth;
    static readyBehaviourSubject: BehaviorSubject<boolean>;
    static readyObs: Observable<boolean>;
    private MAX_UNAUTHORIZED_ATTEMPTS;
    constructor(backend: ConnectionBackend, defaultOptions: RequestOptions, keycloak: Keycloak, keycloakAuth: KeycloakAuthorization);
    get(url: string, options?: RequestOptionsArgs): Observable<Response>;
    post(url: string, body: string, options?: RequestOptionsArgs): Observable<Response>;
    put(url: string, body: string, options?: RequestOptionsArgs): Observable<Response>;
    delete(url: string, options?: RequestOptionsArgs): Observable<Response>;
    patch(url: string, body: string, options?: RequestOptionsArgs): Observable<Response>;
    head(url: string, options?: RequestOptionsArgs): Observable<Response>;
    private configureRequest(url, count, options?);
    private setHeaders(options);
}
